

@ x = ($n << 2)


foreach arg ($argv)
# does it begin with - ?
if ("$arg" =~ -*) then

echo "Argument is an option"
else
echo "Argument is a filename"
endif
end


if ($#argv == 0) then
echo "No filename given. Sending to Report."
set outfile = Report
else
set outfile = $argv[1]
endif

while ($#argv) 
if (-f $argv[1]) then
wc -l $argv[1]
else
echo "$argv[1] is not a regular file"
endif
shift 
end

set user = (alice bob carol ted)
while ($argv[1] != $user[1])

shift user

if ($#user == 0) then
echo "$argv[1] is not on the list of users"
exit 1
endif
end


setenv EXINIT 'set smd sw=4 wm=2'
set history=50
set savehist=50
set ignoreeof noclobber
if ($?prompt) then  
set prompt='[\!]% '  
alias f finger -R  
alias lo logout
endif

set again=yes


set shname = `basename $0`
set progname = $shname:r

# Command file for the program reading CAS SRDL data files

# Check that executable is uptodate
gmake

# Check result of make
if $? != 0 then
  exit 1
endif

# parse command line into arguments
set argv = `getopt dhop:q $*`

# check result of parsing
if ( $? != 0 ) then
  exit 1
endif

set debug = false
set quiet = false
set out = false
set opt  = ''

shift           # skip double dash



set inputDir = /hedat0/SlowDir/srdl/CAS/
set opt = $opt'_-i_'$inputDir

if ! { test -e $inputDir$firstFile } then
  echo File not found: $inputDir$firstFile >& /dev/tty
  exit 1
endif
set opt = $opt'_-f_'$firstFile

if ! { test -e $inputDir$lastFile } then
  echo File not found: $inputDir$lastFile >& /dev/tty
  exit 1
endif
set opt = $opt'_-l_'$lastFile

if ( $out == true ) then
  set OutputFile = $firstFile.out
  if ( $quiet == false & -e $OutputFile ) then
    echo -n 'File' $OutputFile 'already exists, OK to overwrite (y/n)? ' \
      >& /dev/tty
    if ( $< != 'y' ) then
      exit 1
    endif
  endif
  set opt = $opt'_-o_'$OutputFile
endif

set opt = `echo $opt | sed -e "s/_/ /g" `

# execute the process
setenv LD_LIBRARY_PATH "../lib"
$progname $opt >& $firstFile.log

exit 0

set c = 1



set a=$0;
set DIR=$a:h:h
set DATA=/home15/masaka-h

set list = (0 1 2 3 4 5 6 7 8 9)

# Options
set OPTION=1
while ($OPTION)
  switch ($1)
  case -d:
    shift ; set DATA=$1 ; shift;
    breaksw
  case -cn:
    shift ; set cntl=$1 ; shift;
    breaksw
  case -cu:
    shift ; set c=$1 ; shift;
    breaksw
  default:
    set OPTION=0;
    breaksw
  endsw
end

foreach i ($list)
echo $i
    if ( ! -r d$i.basecol || ! -r d$i.basecol.gz ) then
        gzip -d -c < $i.col.gz | egrep '^M' > map
        $DIR/tips/decomp $i.basecol.gz | gzip > d$i.basecol.gz
    endif

    if ( ! -r d$i.col || ! -r d$i.col.gz ) then
        gzip -d -c < $i.col.gz | egrep '^M' > map
        $DIR/tips/decomp $i.col.gz | gzip > d$i.col.gz
    endif
end




set device 		= "/dev/SBA"
set mount_pt	= "/mnt/sba"
set jmode		= $2
set jcommit		= $3
set jsize		= $4
set sepdev		= $5


 set PROGRAMS="1p1 1p2 2p1 2p2 3p1 3p2 4p1 4p2 5p1 5p2"
set DIFFIL = "#differences"

/bin/rm -f $DIFFIL



