


  ! --------------------
  ! Code begins
  ! --------------------
  if(.not. byteSizesOK()) then
    print *, "Compiler does not appear "
    stop
  end if

     forall (i = 1:2, i < 3)
    forall (j = 1:2, l1(i,j))
      it(i, j) = 0
    end forall
  end forall


  IF (task(1:4) == 'STOP') THEN
    IF (task(7:9) == 'CPU') THEN
!restore the previous iterate.
      x(1:n) = t(1:n)
      g(1:n) = r(1:n)
      f = fold
    END IF
    GO TO 999
  END IF



    SELECT CASE ( case1 )
  CASE (    1)
    GO TO 20
  CASE (    2)
    GO TO 50
  CASE (    3)
    GO TO 80
  CASE (    4)
    GO TO 110
END SELECT


!     Compute f0 and g0.

task = 'FG_START'
!          return to the driver to calculate f and g; reenter at 111.
GO TO 1000
111 nfgv = 1

!     Compute the infinity norm of the (-) projected gradient.

    DO j = 1, n
  info = j
  s = 0.0_dp
  jm1 = j - 1
  DO k = 1, jm1
    t = a(k,j) - DOT_PRODUCT( a(1:k-1,k), a(1:k-1,j) )
    t = t/a(k,k)
    a(k,j) = t
    s = s + t*t
  END DO

  s = a(j,j) - s
!     ......exit
  IF (s <= 0.0_dp) GO TO 1000
  a(j,j) = SQRT(s)
END DO
info = 0

CALL projgr(n, l, u, nbd, x, g, sbgnrm)

IF (iprint >= 1) THEN
  WRITE (6,1002) iter, f, sbgnrm
  WRITE (itfile,1003) iter, nfgv, sbgnrm, f
END IF
IF (sbgnrm <= pgtol) THEN
!                                terminate the algorithm.
  task = 'CONVERGENCE: NORM OF PROJECTED GRADIENT <= PGTOL'
  GO TO 999
END IF





!  print *, l1
!  print '(4i2)', it
  if (any (it .ne. reshape ((/1, 0, 0, 4/), (/2, 2/)))) call abort ()

 do while ((input.ne.'n').and.(input.ne.'y'))

write(*,'(a)') 'Enter y or n:'read(*,'(a)') input

end do


1000 RETURN



