

#!/usr/bin/perl -I.

use DBI;


my $psoft_query = <<"EOF";
select distinct TERM_ALT
  from PS_TERM_TBL_BDT_VW
    where (TERM_BEGIN_DT - 10) <= to_date('$today','DD/MM/YYYY')
    and (TERM_END_DT + 10) >= to_date('$today','DD/MM/YYYY')
EOF


my $psoft_query1 = <<"EOF";
select distinct S.EMPLID,
     N.FIRST_NAME, N.LAST_NAME,A.ADDRESS1, A.ADDRESS2, A.ADDRESS3, 
	  A.ADDRESS4, A.CITY, A.STATE, A.COUNTRY, A.POSTAL
  from PS_CQ_STUDY_LOC_VW S,
       PS_CQ_NAME_VW N,
       PS_CQ_ADDR_VW A
  where S.EMPLID = N.EMPLID
    and S.EMPLID = A.EMPLID
    and (S.CQ_STUDY_GP_MEM='Y'
      or S.CQ_STUDY_GP_FAC='Y')
EOF

$psoft_sth1->execute();

# Retreive results of the SQL query
while ( my $psoft_row1 = $psoft_sth1->fetchrow_hashref )
{
 
  print "$postal\n";

  #######################################################################
  # Define SQL query for data retreival
  my $psoft_query2 = <<"EOF";
select distinct CRSE_ID, SUBJECT, CATALOG_NBR
  from PS_CQ_STUD_ENRL_VW
    where EMPLID = '$emplid'
      and STRM = '$term'
EOF

  # Prepare the SQL query
  my $psoft_sth2 = $psoft_dbh->prepare( $psoft_query2 );

  # Execute the SQL query
  $psoft_sth2->execute();

  # Retreive results of the SQL query
  while ( my $psoft_row2 = $psoft_sth2->fetchrow_hashref )
  {
    print "$catalog_nbr\n";

    #######################################################################
    # Define SQL query for data retreival
    my $psoft_query3 = <<"EOF";
select distinct FIRST_NAME, LAST_NAME,
                ADDRESS1, ADDRESS2, ADDRESS3, ADDRESS4, CITY, STATE, COUNTRY, POSTAL
  from PS_CQ_STUDY_LOC_VW S,
       PS_CQ_NAME_VW N,
       PS_CQ_ADDR_VW A,
       PS_CQ_STUD_ENRL_VW E
    where S.EMPLID = N.EMPLID
      and S.EMPLID = A.EMPLID
      and S.EMPLID = E.EMPLID
      and E.STRM= '$term'
      and E.CRSE_ID = '$crse_id'
      and (CQ_STUDY_GP_MEM='Y'
        or CQ_STUDY_GP_FAC='Y')
EOF

    # Prepare the SQL query
    my $psoft_sth3 = $psoft_dbh->prepare( $psoft_query3 );

    # Execute the SQL query
    $psoft_sth3->execute();

   foreach my $bucket (@buckets) {
        my $color = '';

        # See if there's a color file specified
        if ( open COLOR, "<$bucket/color" ) {
            $color = <COLOR>;
      
		     
            if ( !defined( $color ) ) {
                $color = '';
            } else {
                $color =~ s/[\r\n]//g;
            }
            close COLOR;
        }

        load_bucket( $self, $bucket );
        $bucket =~ /([[:alpha:]0-9-_]+)$/;
        $bucket =  $1;
        $self->{full_total} += $self->{total}{$bucket};

        if ( $color eq '' )  {
            if ( $c < $#{$self->{possible_colors}} ) {
                $self->{colors}{$bucket} = $self->{possible_colors}[$c];
            } else {
                $self->{colors}{$bucket} = 'black';
            }
        } else {
            $self->{colors}{$bucket} = $color;
        }

        $c += 1;
    }


 
    $psoft_sth3->finish;

  }


  $psoft_sth2->finish;

}


$psoft_sth1->finish;


$psoft_dbh->disconnect;

#######################################################################
#######################################################################


                      
                      
